#---
# Excerpted from "TextMate",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/textmate for more book information.
#---
source "$TM_SUPPORT_PATH/lib/webpreview.sh"
html_header "TextMate Mini Shell" "bash"

cat <<END_SHELL
<h1>Enter shell commands below:</h1>
<pre><code id="shell"></code></pre>
<script language="JavaScript">
function run_command() {
  var s                = document.getElementById('shell');
  var com              = document.f.com.value;
  s.innerHTML          = s.innerHTML + "<b>$ " + safe(com) + "</b><br>";
  document.f.com.value = "";

	var res     = TextMate.system(com, null).outputString;
  s.innerHTML = s.innerHTML + safe(res).replace(/\n/g, "<br>");

	window.location.hash = "input_form";
}

function safe(str) {
    return str.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;");
}
</script>
<form id="input_form" name="f"
      onsubmit="javascript: run_command(); return false" action="#">
    <input maxlength="2048" size="55" name="com" value="">
    <input value="Run" type="submit">
</form>
END_SHELL

html_footer