#!/usr/bin/env ruby -w
#---
# Excerpted from "TextMate",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/textmate for more book information.
#---

require "rexml/document"

xml = ARGF.read.gsub(/<(.*?)>/) do |tag|
  if    tag.size == 2  then ""
  elsif tag[1]   == ?/ then "</scope>"
  else                      "<scope name='#{$1}'>"
  end
end
doc = REXML::Document.new(xml)

met, cla = "entity.name.function.ruby", "entity.name.type.class.ruby"
doc.elements.each("//scope[@name='#{met}' or @name='#{cla}']") do |tag|
  if tag.attributes["name"] == cla
    puts tag.text
  else
    puts "  " + tag.text
  end
end
