#!/usr/bin/env ruby -w 
#---
# Excerpted from "TextMate",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/textmate for more book information.
#---

require "#{ENV["TM_SUPPORT_PATH"]}/lib/ui" 

count  = TextMate::UI.request_string( :prompt  => "How many fixtures do you need?", 
                                      :button1 => "OK" ).to_i 
fields = TextMate::UI.request_string( :prompt  => "Please enter non-id fields " + 
                                                  "separated by commas:", 
                                      :button1 => "OK" ).split(/,\s*/) 

puts "---" 
count.times do |i| 
  puts "name_me:" 
  puts " id: #{i + 1}" 
  puts fields.map { |f| " #{f.strip}:" } 
end 
