#---
# Excerpted from "TextMate",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/textmate for more book information.
#---
echo "${TM_SELECTED_TEXT:-$TM_CURRENT_WORD}" \
| pbcopy -pboard find

cat <<END_HEAD_HTML
<html><head>
	<title>Quick Scan Results</title>
</head><body>
  <h1>Matches</h1>
  <ul>
END_HEAD_HTML

LINK='<li><a href="txmt:\/\/open?line=\4\&url=file:\/\/\1">\3<\a><\/li>'
find "${TM_PROJECT_DIRECTORY:-$TM_DIRECTORY}"   \
     \( -name "*.rb"   -or -name "*.rhtml"  -or \
        -name "*.rxml" -or -name "*.rjs" \) -or \
     \( -path './vendor' \! -prune \)           \
| xargs grep -n `pbpaste -pboard find`          \
| sed -E 's/^(\/?([^:\/]+\/)+([^:]+)):([0-9]+):.+$/'"$LINK"'/'

cat <<END_FOOT_HTML
  </ul>
</body></html>
END_FOOT_HTML
